<script lang="typescript">
  import {createEventDispatcher} from 'svelte';
  import {Button} from '$lib/components/button';
  import {GridWrap, GridWrapModifier, GridColumn, GridColumnModifier} from '$lib/components/grid';

  import {FragmentId} from '$lib/enums/fragment-ids';

  import {MenuState} from './enums';

  import flossIcon from '$assets/img/svg/icon.svg?url';
  import flossLogo from '$assets/img/svg/logo.svg?url';

  const pageWideEnoughForLogo = 1150;
  const maxScrollY = 400;
  const minScrollY = 200;
  const minIconWidth = 24;
  const maxIconWidth = 42;
  let iconWidth = maxIconWidth;
  let scrolledClass = '';

  const dispatch = createEventDispatcher();
  let menuState = MenuState.Closed;
  let rafId: number;
  let scheduledState: MenuState | undefined;

  import {Icon, IconId} from '$lib/components/icon';
  let toggleElement: HTMLButtonElement;

  $: reactivelyDispatchMenuState(menuState);

  const links = [
    {fragmentId: FragmentId.Course, linkText: 'The course'},
    {fragmentId: FragmentId.WhoIsItFor, linkText: 'Who is it for?'},
    {fragmentId: FragmentId.WhyFloss, linkText: 'Why FLOSS?'},
    {fragmentId: FragmentId.WhoWeAre, linkText: 'Who we are'},
  ];

  export function handleOutsideClick(event: Event): void {
    const {target} = event;
    const element = target instanceof HTMLElement ? target : document.createElement('div');

    if (element !== toggleElement && !toggleElement.contains(element)) {
      closeMenu();
    }
  }

  export function toggleMenu(event: Event): void {
    event.preventDefault();

    const referenceState = scheduledState || menuState;

    menuState = referenceState === MenuState.Open ? MenuState.Closed : MenuState.Open;

    // Page scrolled class is affected by the menuState: we don't show a border when the menu is shown.
    setScheduledState(undefined);

    setHeaderScrolled();
  }

  export function closeMenu(): void {
    menuState = MenuState.Closed;

    setScheduledState(undefined);
  }

  function reactivelyDispatchMenuState(state: MenuState) {
    dispatchMenuState(state);
  }

  function handleBlurFocus(stateToSet: MenuState) {
    return () => {
      setScheduledState(stateToSet);
      scheduleStateChange();
    };
  }

  function scheduleStateChange() {
    cancelAnimationFrame(rafId);

    rafId = requestAnimationFrame(() => {
      if (scheduledState) {
        menuState = scheduledState;
      }
    });
  }

  function setScheduledState(state?: MenuState) {
    scheduledState = state;
  }

  function dispatchMenuState(state: MenuState) {
    dispatch('menustatechange', state);
  }

  // Linear interpolation
  function lerp(v0, v1, t) {
    v0 = 1.0 * v0;
    v1 = 1.0 * v1;
    t = 1.0 * t;
    return (1 - t) * v0 + t * v1;
  }

  // Adjust header on scroll
  function setHeaderScrolled() {
    const scrollY = window.scrollY;

    // Menu bar changes color when scrolled.
    if (scrollY > 2) {
      scrolledClass = ['scrolled', menuState].join(' ');
    } else {
      scrolledClass = '';
    }

    return scrollY;
  }

  // Shows either the Icon or Logo in the header according to page size and scrolling.
  function setHeaderImage() {
    const scrollY = setHeaderScrolled();

    // If the page is big enough,
    // we can show the large logo.
    if (window.innerWidth > pageWideEnoughForLogo) {
      // If we're scrolled down far enough
      // show the large logo by hiding the icon.
      if (scrollY > maxScrollY) {
        iconWidth = 0;
      }

      // If we're scrolled up near the top of the page
      // show the small icon, full size.
      else if (scrollY < minScrollY) {
        iconWidth = maxIconWidth;
      }

      // If we're scrolled in between,
      // transition between the images by linearly scaling down the icon.
      else {
        const t = (scrollY - minScrollY) / (maxScrollY - minScrollY);
        iconWidth = lerp(maxIconWidth, minIconWidth, t);
      }
    }
    // If the page is too small
    // show the small icon, full size.
    else {
      iconWidth = maxIconWidth;
    }
  }
</script>

<svelte:window on:scroll={setHeaderImage} on:resize={setHeaderImage} />

<div class={scrolledClass}>
  <GridWrap>
    <GridColumn>
      <div class="menu__icon">
        <a href={`#${FragmentId.Top}`} title="Return to top">
          <img alt=" " src={flossIcon} width="{iconWidth}px" /><img
            alt=" "
            src={flossLogo}
            width={iconWidth ? '0' : ''}
          />
        </a>
      </div>
      <div class="area-header--portable">
        <button bind:this={toggleElement} class="menu-toggle" on:click={toggleMenu}>
          <div class={menuState}><div /></div>
        </button>
      </div>
    </GridColumn>
    <GridColumn modifiers={[GridWrapModifier.End]} class="menu-container">
      <div class="menu--primary-container" data-css-state={menuState}>
        <GridWrap modifiers={[GridWrapModifier.Middle]}>
          <GridColumn
            modifiers={[GridColumnModifier.ShrinkWrapDesk]}
            viewportMap={{portable: '1-of-1'}}
          >
            <ul class="menu menu--primary">
              {#each links as {fragmentId, linkText}}
                <li class="menu__item">
                  <a
                    on:focus={handleBlurFocus(MenuState.Open)}
                    on:blur={handleBlurFocus(MenuState.Closed)}
                    on:click={closeMenu}
                    href={`#${fragmentId}`}>{linkText}</a
                  >
                </li>
              {/each}
            </ul>
          </GridColumn>

          <GridColumn modifiers={[GridColumnModifier.ShrinkWrap]}>
            <div class="u-padding--large--inline--portable">
              <Button
                on:focus={handleBlurFocus(MenuState.Open)}
                on:blur={handleBlurFocus(MenuState.Closed)}
                on:click={closeMenu}
                href={`#${FragmentId.Subscribe}`}>Stay in touch</Button
              >
            </div>
          </GridColumn>
        </GridWrap>
      </div></GridColumn
    >
  </GridWrap>
</div>
